#!/usr/bin/env python
# -*- coding: utf-8 -*-

import cgi
import cgitb; cgitb.enable()  # for troubleshooting
import dbus

server_name = 'My best mumble-server'
server_id = '1'
coll_channel = 1
img_path = "http://your.site.tut/folder/with/images/"
dbusservice = "net.sourceforge.mumble.murmur"

print("Content-type: text/html; charset: utf-8\n\n")

print """
<html>
<head><title>%s</title></head>
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<style>
	.hide {padding:0px; margin:0px; border:0px white solid; display:none;}
	.showing {padding:0px; margin:0px; border:0px white solid; display:block;}
	.is_users {font-weight:bold;}
</style>
<body style="font-size:12px;">
""" % (server_name)

def printPlayers(channel, presp, pp):
	text = ''
	text1 = ''
	prov = 0
	for p in plist:
		if p[6] == channel:
			if prov == 1:
				text = presp+'<img style="vertical-align:middle;" src="'+img_path+'list_tree_mid.gif">'+text + '<BR>'
				text1 = text1+text
			prov = 1
			text = ''
			if p[3]:
				text = text + '<img style="vertical-align:middle;" src="'+img_path+'player_suppressed.gif">'
			else:
				text = text + '<img style="vertical-align:middle;" src="'+img_path+'list_player.gif">'
			text = text + p[8].encode('utf-8')
			if p[7] > -1:
				text = text + '<img style="vertical-align:middle;" src="'+img_path+'player_auth.gif">'
			if p[1] or p[4]:
				text = text + '<img style="vertical-align:middle;" src="'+img_path+'player_selfmute.gif">'
			if p[2] or p[5]:
				text = text + '<img style="vertical-align:middle;" src="'+img_path+'player_selfdeaf.gif">'
	if prov == 1:
		if pp == 0:
			text = presp+'<img style="vertical-align:middle;" src="'+img_path+'list_tree_end.gif">'+text + '<BR>'
		else:
			text = presp+'<img style="vertical-align:middle;" src="'+img_path+'list_tree_mid.gif">'+text + '<BR>'
		text1 = text1+text
	return text1

def printSubChannel(channel, pres, ur):
	text = ''
	players = ''
	channels = ''
	prov = 0
	chs = chlist
	isp = 0
	for ch1 in chs:
		if ch1[2] == channel:
			if prov == 1:
				pres1 = ''
				if ur > 0:
					pres1 = pres + '<img style="vertical-align:middle;" src="'+img_path+'list_tree_line.gif">'
				channels = printSubChannel(ch[0], pres1, ur+1)
				chfs = channels[0:1]
				channels = channels[1:]
				pp = 1
				if channels == '':
					pp = 0
				players = printPlayers(ch[0], pres+'<img style="vertical-align:middle;" src="'+img_path+'list_tree_line.gif">', pp)
				if (players == '') and (chfs == '0'):
					name = '<img style="vertical-align:middle;" src="'+img_path+'list_channel.gif">'+ch[1].encode('utf-8')+'<BR>'
				else:
					isp = 1
					name = '<img style="vertical-align:middle;" src="'+img_path+'list_channel.gif"><span class="is_users">'+ch[1].encode('utf-8')+'</span><BR>'
				text1 = name
				shb = 'showing'
				if channel > -1:
					if (channels == '') and (players == ''):
						text1 = pres+'<img style="vertical-align:middle;" src="'+img_path+'list_tree_mid.gif">'+name
					else:
						if (players == '') and (chfs == '0') and (coll_channel == 1):
							text1 = pres+'<img style="vertical-align:middle;" onClick="ch_block(\''+str(ch[0])+'\', 0)" id=\'plus'+str(ch[0])+'\' src="'+img_path+'list_tree_mid3.gif">'+name
							shb = 'hide'
						else:
							text1 = pres+'<img style="vertical-align:middle;" onClick="ch_block(\''+str(ch[0])+'\', 0)" id=\'plus'+str(ch[0])+'\' src="'+img_path+'list_tree_mid2.gif">'+name
				
				text = text+text1+'<div class="'+shb+'" id=\'block'+str(ch[0])+'\'>'+players+channels+'</div>'
			ch = ch1
			prov = 1

	if prov == 1:
		pres1 = ''
		if ur > 0:
			pres1 = pres + '<img style="vertical-align:middle;" src="'+img_path+'list_tree_line.gif">'
		channels = printSubChannel(ch[0], pres+'<img style="vertical-align:middle;" src="'+img_path+'list_tree_space.gif">', ur+1)
		chfs = channels[0:1]
		channels = channels[1:]
		pp = 1
		if channels == '':
			pp = 0
		players = printPlayers(ch[0], pres+'<img style="vertical-align:middle;" src="'+img_path+'list_tree_space.gif">', pp)  
		if channel == -1:
			name = '<img style="vertical-align:middle;" src="'+img_path+'mumble.png">'
		else:
			name = '<img style="vertical-align:middle;" src="'+img_path+'list_channel.gif">'
		if (players == '') and (chfs == '0'):
			name = name+ch[1].encode('utf-8')+'<BR>'
		else:
			isp = 1
			name = name+'<B>'+ch[1].encode('utf-8')+'</B><BR>'
		text1 = name
		shb = 'showing'
		if channel > -1:
			if (channels == '') and (players == ''):
				text1 = pres+'<img style="vertical-align:middle;" src="'+img_path+'list_tree_end.gif">'+name
			else:
				if (players == '') and (chfs == '0') and (coll_channel == 1):
					text1 = pres+'<img style="vertical-align:middle;" onClick="ch_block(\''+str(ch[0])+'\', 1)" id=\'plus'+str(ch[0])+'\' src="'+img_path+'list_tree_end3.gif">'+name
					shb = 'hide'
				else:
					text1 = pres+'<img style="vertical-align:middle;" onClick="ch_block(\''+str(ch[0])+'\', 1)" id=\'plus'+str(ch[0])+'\' src="'+img_path+'list_tree_end2.gif">'+name
		text = text+text1+'<div class="'+shb+'" id=\'block'+str(ch[0])+'\'>'+players+channels+'</div>'
	return (str(isp)+text)


err = 0
try:
	dbus_base = dbusservice
	bus = dbus.SystemBus()
	murmur = bus.get_object(dbusservice, '/'+server_id)
except:
	err = 1
if err == 0:
	print """
	<H2>%s</H2>
	""" % (server_name)
	
	chlist = murmur.getChannels()
	plist = murmur.getPlayers()
	vstr = printSubChannel(-1, '', 0)
	print vstr[1:]
else:
	print """
	<H2>Mumble not started</H2>
	"""


print """


<SCRIPT LANGUAGE="JavaScript"> 
//<!--

function ch_block(blockid,lb) {

	el = document.getElementById('block'+blockid);
	el2 = document.getElementById('plus'+blockid);
	tp = 'mid';
	if (lb == 1) {
		tp = 'end';
	};
	if (el.style.display == 'block') {
		el.style.display = 'none';
		el2.src = '"""+img_path+"""list_tree_'+tp+'3.gif'
	} else {
		el.style.display = 'block';
		el2.src = '"""+img_path+"""list_tree_'+tp+'2.gif'
	};

};

//-->
</SCRIPT> 


</body>
</html>
"""